﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using IntelliLock.Licensing;
using System.ServiceModel;
using Contract;

namespace RegisteKey
{
    public partial class KeyForm : Form
    {
        public KeyForm()
        {
            InitializeComponent();
        }

        private void KeyForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (exit == false)
            {
                Environment.Exit(0);
            }
        }
        bool exit = false;

        private void KeyForm_Load(object sender, EventArgs e)
        {
            using (BackgroundWorker worker = new BackgroundWorker())
            {
                worker.DoWork += new DoWorkEventHandler(CheckProcess);
                worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler((obj, args) =>
                {
                    CheckResult result = args.Result as CheckResult;
                    if (result != null)
                    {
                        exit = result.IsValid;
                        labLoading.Text = result.Context;
                        btnEnter.Text = result.IsValid ? "确认" : "获取机器码";
                        btnEnter.Visible = true;
                    }
                });
                worker.RunWorkerAsync();
            }
        }

       
        IContract _context = null;

        void CheckProcess(object sender, DoWorkEventArgs e)
        {
            try
            {
                string name = Helper.GetHardwareID();
                ChannelFactory<IContract> proxy = new ChannelFactory<IContract>("HandRegister_Client");
                proxy.Credentials.UserName.UserName = name;
                _context = proxy.CreateChannel();
                CheckResult result = _context.CheckUser(name);
                e.Result = result;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                Environment.Exit(0);
            }
        }

        private void btnEnter_Click(object sender, EventArgs e)
        {
            if (btnEnter.Text.Equals("获取机器码"))
            {
                string id = Helper.GetHardwareID();
                Clipboard.SetText(id);
                MessageBox.Show(string.Format("机器码{0}已复制成功!", id));
            }
            this.Close();
        }
    }
}
